if(NOT dune-metagrid_FOUND)
# Whether this module is installed or not
set(dune-metagrid_INSTALLED ON)

# Settings specific to the module

# Package initialization

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was dune-metagrid-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

#report other information
set_and_check(dune-metagrid_PREFIX "${PACKAGE_PREFIX_DIR}")
set_and_check(dune-metagrid_INCLUDE_DIRS "${PACKAGE_PREFIX_DIR}/include")
set(dune-metagrid_CXX_FLAGS "-std=c++17 -O2 -pipe -fstack-protector-strong -fno-strict-aliasing")
set(dune-metagrid_CXX_FLAGS_DEBUG "-O2 -pipe -fstack-protector-strong -fno-strict-aliasing")
set(dune-metagrid_CXX_FLAGS_MINSIZEREL "-Os -DNDEBUG")
set(dune-metagrid_CXX_FLAGS_RELEASE "-O2 -pipe -fstack-protector-strong -fno-strict-aliasing")
set(dune-metagrid_CXX_FLAGS_RELWITHDEBINFO "-O2 -g -DNDEBUG")
set(dune-metagrid_DEPENDS "dune-grid (>= 2.8);dune-alugrid (>= 2.8)")
set(dune-metagrid_SUGGESTS "dune-spgrid (>= 2.8) ")
set(dune-metagrid_MODULE_PATH "${PACKAGE_PREFIX_DIR}/share/dune/cmake/modules")
set(dune-metagrid_LIBRARIES "")

# Lines that are set by the CMake build system via the variable DUNE_CUSTOM_PKG_CONFIG_SECTION


#import the target
if(dune-metagrid_LIBRARIES)
  get_filename_component(_dir "${CMAKE_CURRENT_LIST_FILE}" PATH)
  include("${_dir}/dune-metagrid-targets.cmake")
endif()
endif()
